#!/usr/bin/perl -w

# Copyright Cafe.com - Made by Frederic FAURE - fred.faure@gmail.com
# 29 July 2009
#
# requires tcrmgr
#
# Version 0.1
#
# USAGE:
#
# perl tokyotyrant-stats.pl <hostname> <port>
#
# <hostname> is optional and can be an IP address or host name.
#            If none is given, "localhost" is assumed.
#            The Cacti configuration should take care of this.
# <port>     is optional
#            If none is given, "1978" is assumed.
#            The Cacti configuration should take care of this.
#
# LOCAL SETTINGS:
#
# It assumes that tokyotyrant and tokyocabinet are installed to use "tcrmgr".
#

my $hostname = $ARGV[0];
my $port = $ARGV[1];

chomp $hostname;
chomp $port;

if ($hostname eq '') {
        $hostname = "localhost";
}
if ($port eq '') {
        $port = "1978";
}

$RETRIEVER="/usr/local/bin/tcrmgr ";
$CMD = "inform -port ".$port." -st ".$hostname;

my $out = `$RETRIEVER $CMD | awk '{print \$1 ":" \$2}' | egrep 'rnum:|size:|loadavg:|memsize:|memrss:|ru_user:|ru_sys:' | tr "\n" " " | sed 's/\\(ru_user:[0-9]*\\)\\(\\.[0-9]*\\)/\\1/' | sed 's/\\(ru_sys:[0-9]*\\)\\(\\.[0-9]*\\)/\\1/'`;

$CMD = "get -port 1978 ".$hostname." \"tt_".$port."_info_threads\"";

$out .= `$RETRIEVER $CMD | tr "\n" " "`;

$CMD = "get -port 1978 ".$hostname." \"tt_".$port."_info_pcpu\"";

$out .= `$RETRIEVER $CMD | tr "\n" " "`;

$CMD = "mget -port 1978 ".$hostname." \"tt_".$port."_info_socket_NUM\" \"tt_".$port."_info_socket_ESTABLISHED\" \"tt_".$port."_info_socket_TIME_WAIT\" \"tt_".$port."_info_socket_CLOSED\" \"tt_".$port."_info_socket_CLOSE_WAIT\" \"tt_".$port."_info_socket_LISTEN\" \"tt_".$port."_info_socket_CLOSING\"";

$out .= `$RETRIEVER $CMD | awk '{print \$2}' | tr "\n" " "`;

print $out;
